#include "main.h"
#include <irrlicht.h>

irr::IrrlichtDevice *pDevice;
irr::video::IVideoDriver *pVideo;
irr::scene::ISceneManager *pSmgr;
irr::gui::IGUIEnvironment *pGuiEnv;

void init{)
{
	pDevice = irr::createDevice(					
		irr::video::EDT_DIRECT3D9
		);

	pDevice->setWindowCaption(L"Type-A2");

	pVideo = pDevice->getVideoDriver();
	pSmgr = pDevice->getSceneManager();
	pGuiEnv = pDevice->getGUIEnvironment();

	pSmgr->addCameraSceneNode(0, irr::core::vector3df(0,0,-5), irr::core::vector3df(0,0,0));	

}

void update()
{
	static irr::u32 uLastTick=0;
	//и尪
	irr::u32 uTick = pDevice->getTimer()->getTime();						
	irr::f32 fDelta = ((float)(uTick - uLastTick)) / 1000.f; //Ÿ ϱ
	uLastTick = uTick;

	std::vector<irr::video::S3DVertex> Vertices;

	Vertices.push_back(irr::video::S3DVertex(-.5,-.5,0, 0,0,-1,irr::video::SColor(0,0,255,255),0,1) );
	Vertices.push_back(irr::video::S3DVertex(-.5,.5,0, 0,0,-1,irr::video::SColor(0,255,0,255),0,0) );
	Vertices.push_back(irr::video::S3DVertex(.5,.5,0, 0,0,-1,irr::video::SColor(0,255,255,0),1,0) );
	Vertices.push_back(irr::video::S3DVertex(.5,-.5,0, 0,0,-1,irr::video::SColor(0,0,255,0),1,1) );

	std::vector<irr::u16> Indice;

	//0,1,2,3,0,2 
	Indice.push_back(0);
	Indice.push_back(1);
	Indice.push_back(2);
	Indice.push_back(3);
	Indice.push_back(0);
	Indice.push_back(2);

	pVideo->beginScene(true, true, irr::video::SColor(255,100,101,140));

	pSmgr->drawAll();
	pGuiEnv->drawAll();

	// ׸
	{
		irr::core::matrix4 mat;//ķʱȭ
		mat.makeIdentity();
		pVideo->setTransform(irr::video::ETS_WORLD, mat); //ȯʱȭ

		irr::video::SMaterial m;
		m.Lighting = false;  //Ʈ  γ´.
		//m.ZBuffer = false;

		pVideo->setMaterial(m);	
	}

	pVideo->drawIndexedTriangleList((irr::video::S3DVertex *)(&Vertices[0]),
		4,
		(irr::u16 *)&Indice[0],
		2
		);				

	pVideo->endScene();	
}

#ifdef __cplusplus
extern "C" {
#endif

	

	JNIEXPORT void JNICALL Java_com_andrlicht_exam1_main_nativeInit(JNIEnv *env, jobject obj);
	{
		init();

	}

	JNIEXPORT void JNICALL Java_com_andrlicht_exam1_main_nativeSetResDirectory (JNIEnv *, jobject, jstring);
	{}

	JNIEXPORT void JNICALL Java_com_andrlicht_exam1_main_nativeResize (JNIEnv *, jobject, jint, jint);
	{}
	JNIEXPORT void JNICALL Java_com_andrlicht_exam1_main_nativeOnEvent  (JNIEnv *, jobject, jobject);
	{}

	JNIEXPORT void JNICALL Java_com_andrlicht_exam1_main_nativeUpdate (JNIEnv *, jobject)	
	{
		update();
		
	}

#ifdef __cplusplus
}
#endif
