#include "main.h"
#include <irrlicht.h>

irr::IrrlichtDevice *pDevice;
irr::video::IVideoDriver *pVideo;
irr::scene::ISceneManager *pSmgr;
irr::gui::IGUIEnvironment *pGuiEnv;

void init()
{
	pDevice = irr::createDevice(					
		irr::video::EDT_OGLES1,
		irr::core::dimension2du(480,778)
		);

	pDevice->setWindowCaption(L"sample3");

	pVideo = pDevice->getVideoDriver();
	pSmgr = pDevice->getSceneManager();
	pGuiEnv = pDevice->getGUIEnvironment();

	pSmgr->addCameraSceneNode(0, irr::core::vector3df(0,8,-25), irr::core::vector3df(0,0,0));	
	
	{
		irr::scene::ISceneNode *pNode = pSmgr->addCubeSceneNode();
		pNode->setMaterialFlag(irr::video::EMF_LIGHTING,false);
		pNode->setMaterialFlag(irr::video::EMF_WIREFRAME,true);
	}

}

void Init(irr::core::stringc strResDir)
{
	pDevice = irr::createDevice(					
		irr::video::EDT_OGLES1,
		irr::core::dimension2du(480,778)
		);

	pDevice->setWindowCaption(L"exam1");

	pVideo = pDevice->getVideoDriver();
	pSmgr = pDevice->getSceneManager();
	pGuiEnv = pDevice->getGUIEnvironment();
	
	
	pDevice->getFileSystem()->changeWorkingDirectoryTo(strResDir.c_str());

	pSmgr->addCameraSceneNode(0, irr::core::vector3df(0,8,-25), irr::core::vector3df(0,0,0));	
	
	//ť常
	{
		irr::scene::ISceneNode *pNode = pSmgr->addCubeSceneNode();
		pNode->setMaterialFlag(irr::video::EMF_LIGHTING,false);				
		pNode->setMaterialTexture(0, pVideo->getTexture("kim.jpg"));
		
		//ִϸ ߰
		irr::scene::ISceneNodeAnimator *pAnim =
			pSmgr->createRotationAnimator(irr::core::vector3df(
			irr::core::degToRad(45.f),
			irr::core::degToRad(45.f),
			0));
		pNode->addAnimator(pAnim);
		pAnim->drop();	
		
	}

}

void update()
{
	//ð 귯
	pDevice->getTimer()->tick();
	
	static irr::u32 uLastTick=0;
	//и尪
	irr::u32 uTick = pDevice->getTimer()->getTime();						
	irr::f32 fDelta = ((float)(uTick - uLastTick)) / 1000.f; //Ÿ ϱ
	uLastTick = uTick;	
	
	pVideo->beginScene(true, true, irr::video::SColor(255,100,101,140));

	pSmgr->drawAll();
	pGuiEnv->drawAll();
		

	pVideo->endScene();	
}

void resize(int w,int h)
{
	irr::core::dimension2du size(w,h);
	pVideo->OnResize(size);
}

#ifdef __cplusplus
extern "C" {
#endif
/*
 * Class:     gbox3d_andrlicht_exam1_Actv_anrl_exam1
 * Method:    nativeInit
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_gbox3d_andrlicht_exam1_Actv_1anrl_1exam1_nativeInit__
  (JNIEnv *env, jobject obj)
  {
  	init();
  }
  
  
/*
 * Class:     gbox3d_andrlicht_exam1_Actv_anrl_exam1
 * Method:    nativeInit
 * Signature: (Ljava/lang/String;)V
 */
JNIEXPORT void JNICALL Java_gbox3d_andrlicht_exam1_Actv_1anrl_1exam1_nativeInit__Ljava_lang_String_2
  (JNIEnv *env, jobject jobj, jstring directory_name)
  {
  	const char *ch = env->GetStringUTFChars(directory_name,0);
  	Init(irr::core::stringc(ch));
  	env->ReleaseStringUTFChars(directory_name,ch);  	
  }
  

/*
 * Class:     gbox3d_andrlicht_exam1_Actv_anrl_exam1
 * Method:    nativeSetResDirectory
 * Signature: (Ljava/lang/String;)V
 */
JNIEXPORT void JNICALL Java_gbox3d_andrlicht_exam1_Actv_1anrl_1exam1_nativeSetResDirectory
  (JNIEnv *env, jobject obj, jstring strResDir)
  {
  }

/*
 * Class:     gbox3d_andrlicht_exam1_Actv_anrl_exam1
 * Method:    nativeResize
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_gbox3d_andrlicht_exam1_Actv_1anrl_1exam1_nativeResize
  (JNIEnv *env, jobject obj, jint w, jint h)
  {
  	resize(w,h);
  }

/*
 * Class:     gbox3d_andrlicht_exam1_Actv_anrl_exam1
 * Method:    nativeOnEvent
 * Signature: (Lgbox3d/andrlicht/exam1/irrEvent;)V
 */
JNIEXPORT void JNICALL Java_gbox3d_andrlicht_exam1_Actv_1anrl_1exam1_nativeOnEvent
  (JNIEnv *env, jobject obj, jobject objEvent)
  {
  }

/*
 * Class:     gbox3d_andrlicht_exam1_Actv_anrl_exam1
 * Method:    nativeUpdate
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_gbox3d_andrlicht_exam1_Actv_1anrl_1exam1_nativeUpdate
  (JNIEnv *env, jobject obj)
  {
  	update();
  }

#ifdef __cplusplus
}
#endif

